package com.loit.loitcasclient.utils;

import com.loit.loitcasclient.config.ClientAppConfig;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.util.StringUtils;
import org.springframework.web.client.RestTemplate;

@Component("clientUserUtil")
public class ClientUserUtil {
    @Autowired
    private RestTemplate restTemplate;
    @Autowired(required = false)
    private ClientAppConfig clientAppConfig;

    /**
     * 获取登录用户id-从缓存中获取
     * @param accessToken
     * @return
     */
    public String getUserId(String accessToken){
        if(StringUtils.isEmpty(accessToken)){
            return null;
        }
        // 从缓存获取userId, 如果没有则从登录服务器获取userId, 然后存入缓存
        Object o = ClientLocalCacheUtil.get(accessToken);
        if(null != o && !String.valueOf(o).equals("")){
            return String.valueOf(o);
        }

        String userId = getCasServerUserId(accessToken);
        return userId;
    }

    /**
     * 获取登录用户id-从登录服务器获取
     */
    public String getCasServerUserId(String accessToken){
        String userId = ClientTokenUtil.profile(clientAppConfig.profileUrl().replace("{accessToken}", accessToken), restTemplate);
        return userId;
    }
}
